//------------------------------------------------------------------
#property copyright   "www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  Silver
#property indicator_color4  clrDeepSkyBlue
#property indicator_color5  clrSandyBrown
#property indicator_color6  clrSandyBrown
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame           = PERIOD_CURRENT; // Time frame
extern string             ForSymbol           = "";             // For symbol (leave empty for current chart symbol)
extern int                SF                  = 5;              // Smoothing factor
extern int                RsiPeriod           = 32;             // Rsi period
extern ENUM_APPLIED_PRICE RsiPrice            = PRICE_CLOSE;    // Rsi price
extern double             WP                  = 3.0;            // WP factor
extern bool               alertsOn            = false;          // Turn alerts on?
extern bool               alertsOnSlope       = true;           // Alerts on slope change?
extern bool               alertsOnSignalCross = true;           // Alerts on signal line cross?
extern bool               alertsOnCurrent     = true;           // Alerts on current (still opened) bar?
extern bool               alertsMessage       = true;           // Alerts should display a message?
extern bool               alertsSound         = false;          // Alerts should play a sound?
extern bool               alertsEmail         = false;          // Alerts should send an email?

//
//
//
//
//

double TrendU[];
double TrendDa[];
double TrendDb[];
double RsiMa[];
double RsiMaDa[];
double RsiMaDb[];
double slope[];
double trend[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,RsiMa);    SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,RsiMaDa);  SetIndexLabel(1, "QQE down");
   SetIndexBuffer(2,RsiMaDb);  SetIndexLabel(2, "QQE down");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(1, "QQE trend up");
   SetIndexBuffer(4,TrendDa);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(5,TrendDb);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(6,slope); 
   SetIndexBuffer(7,trend); 
   
       //
       //
       //
       //
       //
      
          indicatorFileName = WindowExpertName();
          returnBars        = (TimeFrame==-99);
          TimeFrame         = MathMax(TimeFrame,_Period);
          if (ForSymbol=="") ForSymbol = _Symbol;
   IndicatorShortName(ForSymbol+" "+timeFrameToString(TimeFrame)+"  QQE ("+(string)SF+","+(string)RsiPeriod+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double emas[][3];
#define iEma 0
#define iEmm 1
#define iQqe 2

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { RsiMa[0] = limit+1; return(0); }
            if (TimeFrame != Period() || ForSymbol!=_Symbol)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period())); 
               if (slope[limit]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
               if (trend[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     TrendDa[i] = EMPTY_VALUE;
                     TrendDb[i] = EMPTY_VALUE;
                     RsiMaDa[i] = EMPTY_VALUE;
                     RsiMaDb[i] = EMPTY_VALUE;
                     RsiMa[i]   = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",SF,RsiPeriod,RsiPrice,WP,alertsOn,alertsOnSlope,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
                     TrendU[i]  = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",SF,RsiPeriod,RsiPrice,WP,alertsOn,alertsOnSlope,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y); 
                     slope[i]   = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",SF,RsiPeriod,RsiPrice,WP,alertsOn,alertsOnSlope,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6,y);
                     trend[i]   = iCustom(ForSymbol,TimeFrame,indicatorFileName,PERIOD_CURRENT,"",SF,RsiPeriod,RsiPrice,WP,alertsOn,alertsOnSlope,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,7,y); 
               }
               for(int i=limit; i>=0; i--)
               {
                  if (slope[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
                  if (trend[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
               }
               return(0);
            }

   //
   //
   //
   //
   //

     if (ArrayRange(emas,0) != Bars) { ArrayResize(emas,Bars);  }
     if (slope[limit]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
     if (trend[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);

     double alpha1 = 2.0/(SF+1.0);
     double alpha2 = 2.0/(RsiPeriod*2.0);
      
     for (int i=limit, r=Bars-i-1; i>=0; i--,r++)
     {  
         double rsi = iRsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),RsiPeriod,i);
            if (r<1) { RsiMa[i] = rsi; emas[r][iEma] = rsi; emas[r][iEmm] = rsi; continue; }
            RsiMa[i] = RsiMa[i+1] + alpha1*(rsi - RsiMa[i+1]);
            emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
            emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

            //
            //
            //
            //
            //

           double rsi0 = RsiMa[i];
           double rsi1 = RsiMa[i+1];
           double dar  = emas[r  ][iEmm]*WP;
           double tr   = emas[r-1][iQqe];
           double dv   = tr;
   
              if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
              if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
            //
            //
            //
            //
            //
         
           TrendU[i]     = tr;
           emas[r][iQqe] = tr;
           TrendDa[i]    = EMPTY_VALUE;
           TrendDb[i]    = EMPTY_VALUE;
           RsiMaDa[i]    = EMPTY_VALUE;
           RsiMaDb[i]    = EMPTY_VALUE;
           slope[i]      = slope[i+1];
           trend[i]      = trend[i+1];

              if (RsiMa[i]>RsiMa[i+1]) slope[i] =  1;
              if (RsiMa[i]<RsiMa[i+1]) slope[i] = -1;
              if (tr     < RsiMa[i]  ) trend[i] =  1;
              if (tr     > RsiMa[i]  ) trend[i] = -1;

         if (slope[i] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (trend[i] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
   }    
   manageAlerts();    
   return(0);
}   

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," QQE sloping up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," QQE sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," QQE crossed signal line up");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," QQE crossed signal line down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(_Period)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," QQE "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}